import numpy as np
"""slice trajectory by atom indices and calculate the radius of gyration for each polymer chain"""

def RadiusOfGyration(Pos):
    """Calculate radius of gyration"""
        COM = np.mean(Pos, axis=0)
        b = (np.linalg.norm(abs(Pos-COM),axis=1))**2 # array of (r_i-r)^2
        Rg_sqr=np.mean(b)
        Rg=Rg_sqr**0.5
        return Rg

def writeData(PosArray,DOPs = [60,60],fName='rg.txt'):
    """DOPs: list of degrees of polymerization for all chains
        Rg: list of Rg of all chains from every frame"""
    Rg = []
    for i, DOP in enumerate(DOP):
        rgChain = 0
        for Pos in PosArray:
            idx0 = i*DOP
            idx1 = idx0 +DOP
            rgChain.append(RadiusOfGyration(Pos[idx0:idx1]))
    Rg.append(rgChain)
    np.savetxt(fName,Rg,header='RgA RgB')
    return Rg
